/*
 * gtk 1.x 2.x  ٸ 
 *
 * Copyright (C) 2002, Nam SungHyun and various contributors
 */
#include "config.h"
#include "pcMain.h"

#if GTK_MAJOR_VERSION >= 2
#include <sys/time.h>

/* gdk_time_get() {{{1 */
guint32
gdk_time_get(void)
{
    struct timeval end;
    struct timeval elapsed;
    guint32 milliseconds;

    static int f = 1;
    static struct timeval start;
    if (f)
    {
	f=0;
	gettimeofday (&start, NULL);
    }

    gettimeofday (&end, NULL);

    if (start.tv_usec > end.tv_usec)
    {
	end.tv_usec += 1000000;
	end.tv_sec--;
    }
    elapsed.tv_sec = end.tv_sec - start.tv_sec;
    elapsed.tv_usec = end.tv_usec - start.tv_usec;

    milliseconds = (elapsed.tv_sec * 1000) + (elapsed.tv_usec / 1000);

    return milliseconds;
}

/* PC_IconvStr() {{{1 */
char *
PC_IconvStr(const char *from, int fromlen)
{
    g_return_val_if_fail(from != NULL && fromlen > 0, (char *) from);

    if (g_utf8_validate(from, fromlen, NULL) == FALSE)
    {
	gchar *p;
	gsize bytes_read, bytes_written;

	p = g_locale_to_utf8(from, fromlen, &bytes_read, &bytes_written,
			     NULL);
	if (p != NULL)
	    return p;
    }

    return (char *) from;
}

/* marshal_VOID__OBJECT_OBJECT() {{{1 */
/* VOID:OBJECT,OBJECT (gtkmarshalers.list:69) */
void
marshal_VOID__OBJECT_OBJECT (GClosure     *closure,
			     GValue       *return_value,
			     guint         n_param_values,
			     const GValue *param_values,
			     gpointer      invocation_hint,
			     gpointer      marshal_data)
{
  typedef void (*GMarshalFunc_VOID__OBJECT_OBJECT) (gpointer     data1,
                                                    gpointer     arg_1,
                                                    gpointer     arg_2,
                                                    gpointer     data2);
  register GMarshalFunc_VOID__OBJECT_OBJECT callback;
  register GCClosure *cc = (GCClosure*) closure;
  register gpointer data1, data2;

  UNUSED(return_value);
  UNUSED(invocation_hint);

  g_return_if_fail (n_param_values == 3);

  if (G_CCLOSURE_SWAP_DATA (closure))
    {
      data1 = closure->data;
      data2 = g_value_peek_pointer (param_values + 0);
    }
  else
    {
      data1 = g_value_peek_pointer (param_values + 0);
      data2 = closure->data;
    }
  callback = (GMarshalFunc_VOID__OBJECT_OBJECT) (marshal_data ? marshal_data : cc->callback);

  callback (data1,
            g_value_get_object (param_values + 1),
            g_value_get_object (param_values + 2),
            data2);
}

/* }}} */

#else /* GTK_MAJOR_VERSION < 2 */

/* }}} */
#endif

